﻿Imports System.IO
Imports System.Xml.Serialization

Public Class FenetreListePatient
    Private nbPatient As Integer
    Private nbBilanRestant As Integer
    Private nbBilanImpRestant As Integer
    Private SPmoyenAvancement As Integer
    Private bilanAvenir As Integer
    Private _FenetreAjout As PatientDialog
    Private _PatientEnVisualisation As Patient
    Private _ListePatients As List(Of Patient)
    Private _dateNow As Date

    Public Property ListePatients As List(Of Patient)
        Get
            Return _ListePatients
        End Get
        Set(ByVal value As List(Of Patient))
            _ListePatients = value
        End Set
    End Property
    Private Sub ListePatients_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        
        Me.LabelPrenomPatient.Text = ""
        Me.LabelNomPatient.Text = ""
        Me.ProgressBarResum.Value = 0
        _dateNow = Date.Now
        ' Dim valCurrentRw As DataGridViewRow

        'Instancie une nouvelle liste
        _ListePatients = New List(Of Patient)
        'Récupère les infos
        Deserialisation()
        'MAJ la liste de films
        UpdateListe()
    End Sub
    Private Sub ListePatients_FormClosing(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.FormClosing
        'Sérialise les patients lors de la fermeture
        Serialisation()
    End Sub
    Private Sub DataGridViewPatient_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DataGridViewPatient.CellClick
        'On vérifie qu'on a sélectionné quelque chose
        If Not Me.DataGridViewPatient.SelectedRows Is Nothing Then
            'Retrouve le patient avec ce nom
            Me.ButtonEditPatient.Enabled = True
            Me.ButtonSupprimer.Enabled = True
            Dim val As DataGridViewRow = Me.DataGridViewPatient.CurrentRow
            For Each PatientALister As Patient In _ListePatients
                If PatientALister.Nom = val.Cells.Item(0).Value.ToString And PatientALister.Prenom = val.Cells.Item(1).Value.ToString Then
                    'L'insère dans une variable globale
                    Me._PatientEnVisualisation = PatientALister
                End If
            Next
            'On MAJ les infos de la fiche
            Me.LabelPrenomPatient.Text = Me._PatientEnVisualisation.Prenom
            Me.LabelNomPatient.Text = Me._PatientEnVisualisation.Nom
            Me.ProgressBarResum.Value = Me._PatientEnVisualisation.PercentAvancement
            Me.notesRichText.Text = Me._PatientEnVisualisation.Notes
            If Me._PatientEnVisualisation.QuestionnairesOK Then
                Me.LabelQuestionnaires.Font = New Font(LabelQuestionnaires.Font, FontStyle.Strikeout)
            Else
                Me.LabelQuestionnaires.Font = New Font(LabelQuestionnaires.Font, FontStyle.Bold)
            End If
            If Me._PatientEnVisualisation.AnamneseOK Then
                Me.LabelAnamnese.Font = New Font(LabelAnamnese.Font, FontStyle.Strikeout)
            Else
                Me.LabelAnamnese.Font = New Font(LabelAnamnese.Font, FontStyle.Bold)
            End If
            If Me._PatientEnVisualisation.ComportementOK Then
                Me.LabelComportement.Font = New Font(LabelComportement.Font, FontStyle.Strikeout)
            Else
                Me.LabelComportement.Font = New Font(LabelComportement.Font, FontStyle.Bold)
            End If
            If Me._PatientEnVisualisation.CotationOK Then
                Me.LabelCotation.Font = New Font(LabelCotation.Font, FontStyle.Strikeout)
            Else
                Me.LabelCotation.Font = New Font(LabelCotation.Font, FontStyle.Bold)
            End If
            If Me._PatientEnVisualisation.WISCaTeachOK Then
                Me.LabelDeWISaTE.Font = New Font(LabelDeWISaTE.Font, FontStyle.Strikeout)
            Else
                Me.LabelDeWISaTE.Font = New Font(LabelDeWISaTE.Font, FontStyle.Bold)
            End If
            If Me._PatientEnVisualisation.TEACHaReyOK Then
                Me.LabelDeTEaRe.Font = New Font(LabelDeTEaRe.Font, FontStyle.Strikeout)
            Else
                Me.LabelDeTEaRe.Font = New Font(LabelDeTEaRe.Font, FontStyle.Bold)
            End If
            If Me._PatientEnVisualisation.CclConseilsOK Then
                Me.LabelConclusion.Font = New Font(LabelConclusion.Font, FontStyle.Strikeout)
            Else
                Me.LabelConclusion.Font = New Font(LabelConclusion.Font, FontStyle.Bold)
            End If
            If Me._PatientEnVisualisation.AmenagementsOK Then
                Me.LabelAmenagement.Font = New Font(LabelAmenagement.Font, FontStyle.Strikeout)
            Else
                Me.LabelAmenagement.Font = New Font(LabelAmenagement.Font, FontStyle.Bold)
            End If
            If Me._PatientEnVisualisation.CRparentsOK Then
                Me.LabelCRparents.Font = New Font(LabelCRparents.Font, FontStyle.Strikeout)
            Else
                Me.LabelCRparents.Font = New Font(LabelCRparents.Font, FontStyle.Bold)
            End If
            If Me._PatientEnVisualisation.CRproOK Then
                Me.LabelCRpro.Font = New Font(LabelCRpro.Font, FontStyle.Strikeout)
            Else
                Me.LabelCRpro.Font = New Font(LabelCRpro.Font, FontStyle.Bold)
            End If
        End If
    End Sub
    Public Sub UpdateListe()
        ' vide la liste pour la reremplire
        Me.DataGridViewPatient.Rows.Clear()
        nbPatient = 0
        nbBilanRestant = 0
        nbBilanImpRestant = 0
        SPmoyenAvancement = 0
        bilanAvenir = 0
        Dim pMoyenAvancement As Integer
        'Parcourt les patients de la liste
        For Each PatientALister As Patient In _ListePatients
            nbPatient = nbPatient + 1
            'Remplit le Datagridview
            Me.DataGridViewPatient.Rows.Add(PatientALister.Nom, PatientALister.Prenom, PatientALister.DateConsult, PatientALister.PercentAvancement, PatientALister.Priorite)
            'If PatientALister.PercentAvancement < 100 Then
            '    nbBilanRestant = nbBilanRestant + 1
            'End If
            
            If PatientALister.Priorite = 1 Then
                nbBilanImpRestant = nbBilanImpRestant + 1
            End If

            If PatientALister.PercentAvancement < 100 And DateTime.Compare(PatientALister.DateConsult.ToShortDateString, _dateNow.ToShortDateString) <= 0 Then
                SPmoyenAvancement = SPmoyenAvancement + PatientALister.PercentAvancement
                nbBilanRestant = nbBilanRestant + 1
            End If
            If DateTime.Compare(PatientALister.DateConsult.ToShortDateString, _dateNow.ToShortDateString) > 0 Then
                bilanAvenir = bilanAvenir + 1
            End If

        Next
        Me.DataGridViewPatient.ClearSelection()
        Me.DataGridViewPatient.Columns(2).DefaultCellStyle.Format = "dd-MM-yyyy"
        Me.DataGridViewPatient.Sort(DataGridViewPatient.Columns(0), System.ComponentModel.ListSortDirection.Ascending)
        Me.NbBilanRestantLabel.Text = nbBilanRestant & " restant(s) "
        Me.NbPatientLabel.Text = "Total : " & nbPatient
        Me.BilanImpRestLabel.Text = "dont " & nbBilanImpRestant & " urgent(s)"
        Me.bilanAvenirLabel.Text = "A venir : " & bilanAvenir
        If nbBilanRestant = 0 Then
            Me.PmoyAvanLabel.Font = New Font(PmoyAvanLabel.Font, FontStyle.Bold)
            Me.PmoyAvanLabel.ForeColor = Color.Green
            Me.PmoyAvanLabel.Text = "CR à jour"
        Else
            pMoyenAvancement = (SPmoyenAvancement / nbBilanRestant)
            Me.PmoyAvanLabel.Font = New Font(PmoyAvanLabel.Font, FontStyle.Regular)
            Me.PmoyAvanLabel.ForeColor = Color.Black
            Me.PmoyAvanLabel.Text = "Avancement moyen : " & pMoyenAvancement & " %"
        End If

        Me.ButtonEditPatient.Enabled = False
        Me.ButtonSupprimer.Enabled = False

        'On reinitialise à vide les infos de la fiche
        Me.LabelPrenomPatient.Text = ""
        Me.LabelNomPatient.Text = ""
        Me.ProgressBarResum.Value = 0
        Me.notesRichText.Text = ""
        Me.LabelQuestionnaires.Font = New Font(LabelQuestionnaires.Font, FontStyle.Bold)
        Me.LabelAnamnese.Font = New Font(LabelAnamnese.Font, FontStyle.Bold)
        Me.LabelComportement.Font = New Font(LabelComportement.Font, FontStyle.Bold)
        Me.LabelCotation.Font = New Font(LabelCotation.Font, FontStyle.Bold)
        Me.LabelDeWISaTE.Font = New Font(LabelDeWISaTE.Font, FontStyle.Bold)
        Me.LabelDeTEaRe.Font = New Font(LabelDeTEaRe.Font, FontStyle.Bold)
        Me.LabelConclusion.Font = New Font(LabelConclusion.Font, FontStyle.Bold)
        Me.LabelAmenagement.Font = New Font(LabelAmenagement.Font, FontStyle.Bold)
        Me.LabelCRparents.Font = New Font(LabelCRparents.Font, FontStyle.Bold)
        Me.LabelCRpro.Font = New Font(LabelCRpro.Font, FontStyle.Bold)
       
    End Sub
    Private Sub ButtonSupprimer_Click(sender As System.Object, e As System.EventArgs) Handles ButtonSupprimer.Click
        'Confirmation
        If MsgBox("Supprimer " & _PatientEnVisualisation.Nom & " " & _PatientEnVisualisation.Prenom & " ?", MsgBoxStyle.YesNo, "confirmation") = MsgBoxResult.Yes Then
            'On le retire de la liste
            Me._ListePatients.Remove(_PatientEnVisualisation)
        End If
        'MAJ
        UpdateListe()
    End Sub
    Private Sub ButtonNouveauPatient_Click(sender As System.Object, e As System.EventArgs) Handles ButtonNouveauPatient.Click
        'Si nouveau patient, on passe nothing
        _FenetreAjout = New PatientDialog(Nothing)
        _FenetreAjout.Show()
    End Sub

    Private Sub ButtonEditPatient_Click(sender As System.Object, e As System.EventArgs) Handles ButtonEditPatient.Click
        'Si une MAJ, on passe le paramètre du patient actuel
        _FenetreAjout = New PatientDialog(_PatientEnVisualisation)
        _FenetreAjout.Show()
    End Sub

    Private Sub DataGridViewPatient_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DataGridViewPatient.DoubleClick
        _FenetreAjout = New PatientDialog(_PatientEnVisualisation)
        _FenetreAjout.Show()
    End Sub


#Region "sauvegarde et recupération"
    Private Sub Deserialisation()
        If File.Exists("EtatABP.xml") Then
            'On ouvre le fichier et récupère son flux
            Dim FluxDeFichier As Stream = File.OpenRead("EtatABP.xml")
            Dim Deserialiseur As New XmlSerializer(GetType(List(Of Patient)))
            'Désérialisation et conversion de ce qu'on récupère dans le type « Film »
            _ListePatients = Deserialiseur.Deserialize(FluxDeFichier)
            'Fermeture du flux
            FluxDeFichier.Close()
        End If
    End Sub

    Private Sub Serialisation()
        'On crée le fichier et récupère son flux
        Dim FluxDeFichier As FileStream = File.Create("EtatABP.xml")
        Dim Serialiseur As New XmlSerializer(GetType(List(Of Patient)))
        'Sérialisation et écriture
        Serialiseur.Serialize(FluxDeFichier, _ListePatients)
        'Fermeture du fichier
        FluxDeFichier.Close()
    End Sub
#End Region

    
End Class
